Index: drivers/filesystems/btrfs/create.c
===================================================================
--- drivers/filesystems/btrfs/create.c	(révision 74430)
+++ drivers/filesystems/btrfs/create.c	(copie de travail)
@@ -1041,76 +792,187 @@
                 ier = (INODE_EXTREF*)&ier->name[ier->n];
             }
         } else if (tp.item->key.obj_type == TYPE_XATTR_ITEM) {
-            if (tp.item->size < sizeof(DIR_ITEM)) {
-                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(DIR_ITEM));
+            ULONG len;
+            DIR_ITEM* di;
+            
+            static char xapref[] = "user.";
+            
+            if (tp.item->size < offsetof(DIR_ITEM, name[0])) {
+                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, offsetof(DIR_ITEM, name[0]));
                 continue;
             }
             
-            if (tp.item->key.offset == EA_REPARSE_HASH) {
-                UINT8* xattrdata;
-                UINT16 xattrlen;
+            len = tp.item->size;
+            di = (DIR_ITEM*)tp.item->data;
+            
+            do {
+                if (len < offsetof(DIR_ITEM, name[0]) + di->m + di->n)
+                    break;
                 
-                if (extract_xattr(tp.item->data, tp.item->size, EA_REPARSE, &xattrdata, &xattrlen)) {
-                    fcb->reparse_xattr.Buffer = (char*)xattrdata;
-                    fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = xattrlen;
-                }
-            } else if (tp.item->key.offset == EA_EA_HASH) {
-                UINT8* eadata;
-                UINT16 ealen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_EA, &eadata, &ealen)) {
-                    ULONG offset;
+                if (tp.item->key.offset == EA_REPARSE_HASH && di->n == strlen(EA_REPARSE) && RtlCompareMemory(EA_REPARSE, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        fcb->reparse_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                        if (!fcb->reparse_xattr.Buffer) {
+                            ERR("out of memory\n");
+                            free_fcb(fcb);
+                            return STATUS_INSUFFICIENT_RESOURCES;
+                        }
+                        
+                        RtlCopyMemory(fcb->reparse_xattr.Buffer, &di->name[di->n], di->m);
+                    } else
+                        fcb->reparse_xattr.Buffer = NULL;
                     
-                    Status = IoCheckEaBufferValidity((FILE_FULL_EA_INFORMATION*)eadata, ealen, &offset);
-                    
-                    if (!NT_SUCCESS(Status)) {
-                        WARN("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
-                        ExFreePool(eadata);
-                    } else {
-                        FILE_FULL_EA_INFORMATION* eainfo;
-                        fcb->ea_xattr.Buffer = (char*)eadata;
-                        fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = ealen;
+                    fcb->reparse_xattr.Length = fcb->reparse_xattr.MaximumLength = di->m;
+                } else if (tp.item->key.offset == EA_EA_HASH && di->n == strlen(EA_EA) && RtlCompareMemory(EA_EA, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        ULONG offset;
                         
-                        fcb->ealen = 4;
+                        Status = IoCheckEaBufferValidity((FILE_FULL_EA_INFORMATION*)&di->name[di->n], di->m, &offset);
                         
-                        // calculate ealen
-                        eainfo = (FILE_FULL_EA_INFORMATION*)eadata;
-                        do {
-                            fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
+                        if (!NT_SUCCESS(Status))
+                            WARN("IoCheckEaBufferValidity returned %08x (error at offset %u)\n", Status, offset);
+                        else {
+                            FILE_FULL_EA_INFORMATION* eainfo;
                             
-                            if (eainfo->NextEntryOffset == 0)
-                                break;
+                            fcb->ea_xattr.Buffer = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                            if (!fcb->ea_xattr.Buffer) {
+                                ERR("out of memory\n");
+                                free_fcb(fcb);
+                                return STATUS_INSUFFICIENT_RESOURCES;
+                            }
                             
-                            eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
-                        } while (TRUE);
+                            RtlCopyMemory(fcb->ea_xattr.Buffer, &di->name[di->n], di->m);
+                            
+                            fcb->ea_xattr.Length = fcb->ea_xattr.MaximumLength = di->m;
+                             
+                            fcb->ealen = 4;
+                            
+                            // calculate ealen
+                            eainfo = (FILE_FULL_EA_INFORMATION*)&di->name[di->n];
+                            do {
+                                fcb->ealen += 5 + eainfo->EaNameLength + eainfo->EaValueLength;
+                                
+                                if (eainfo->NextEntryOffset == 0)
+                                    break;
+                                
+                                eainfo = (FILE_FULL_EA_INFORMATION*)(((UINT8*)eainfo) + eainfo->NextEntryOffset);
+                            } while (TRUE);
+                        }
                     }
-                }
-            } else if (tp.item->key.offset == EA_DOSATTRIB_HASH) {
-                UINT8* xattrdata;
-                UINT16 xattrlen;
-                
-                if (extract_xattr(tp.item->data, tp.item->size, EA_DOSATTRIB, &xattrdata, &xattrlen)) {
-                    if (get_file_attributes_from_xattr((char*)xattrdata, xattrlen, &fcb->atts)) {
-                        atts_set = TRUE;
+                } else if (tp.item->key.offset == EA_DOSATTRIB_HASH && di->n == strlen(EA_DOSATTRIB) && RtlCompareMemory(EA_DOSATTRIB, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        if (get_file_attributes_from_xattr(&di->name[di->n], di->m, &fcb->atts)) {
+                            atts_set = TRUE;
+                            
+                            if (fcb->type == BTRFS_TYPE_DIRECTORY)
+                                fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
+                            else if (fcb->type == BTRFS_TYPE_SYMLINK)
+                                fcb->atts |= FILE_ATTRIBUTE_REPARSE_POINT;
+                        }
+                    }
+                } else if (tp.item->key.offset == EA_NTACL_HASH && di->n == strlen(EA_NTACL) && RtlCompareMemory(EA_NTACL, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        fcb->sd = ExAllocatePoolWithTag(PagedPool, di->m, ALLOC_TAG);
+                        if (!fcb->sd) {
+                            ERR("out of memory\n");
+                            free_fcb(fcb);
+                            return STATUS_INSUFFICIENT_RESOURCES;
+                        }
                         
-                        if (fcb->type == BTRFS_TYPE_DIRECTORY)
-                            fcb->atts |= FILE_ATTRIBUTE_DIRECTORY;
-                        else if (fcb->type == BTRFS_TYPE_SYMLINK)
-                            fcb->atts |= FILE_ATTRIBUTE_REPARSE_POINT;
+                        RtlCopyMemory(fcb->sd, &di->name[di->n], di->m);
+                        
+                        if (get_sd_from_xattr(fcb, di->m))
+                            sd_set = TRUE;
+                        else {
+                            ExFreePool(fcb->sd);
+                            fcb->sd = NULL;
+                        }
                     }
+                } else if (tp.item->key.offset == EA_PROP_COMPRESSION_HASH && di->n == strlen(EA_PROP_COMPRESSION) && RtlCompareMemory(EA_PROP_COMPRESSION, di->name, di->n) == di->n) {
+                    if (di->m > 0) {
+                        const char lzo[] = "lzo";
+                        const char zlib[] = "zlib";
+                        
+                        if (di->m == strlen(lzo) && RtlCompareMemory(&di->name[di->n], lzo, di->m) == di->m)
+                            fcb->prop_compression = PropCompression_LZO;
+                        else if (di->m == strlen(zlib) && RtlCompareMemory(&di->name[di->n], zlib, di->m) == di->m)
+                            fcb->prop_compression = PropCompression_Zlib;
+                        else
+                            fcb->prop_compression = PropCompression_None;
+                    }
+                } else if (di->n > strlen(xapref) && RtlCompareMemory(xapref, di->name, strlen(xapref)) == strlen(xapref)) {
+                    dir_child* dc;
+                    ULONG utf16len;
                     
-                    ExFreePool(xattrdata);
+                    Status = RtlUTF8ToUnicodeN(NULL, 0, &utf16len, &di->name[strlen(xapref)], di->n - strlen(xapref));
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUTF8ToUnicodeN 1 returned %08x\n", Status);
+                        free_fcb(fcb);
+                        return Status;
+                    }
+                    
+                    dc = ExAllocatePoolWithTag(PagedPool, sizeof(dir_child), ALLOC_TAG);
+                    if (!dc) {
+                        ERR("out of memory\n");
+                        free_fcb(fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+                    
+                    RtlZeroMemory(dc, sizeof(dir_child));
+                    
+                    dc->utf8.MaximumLength = dc->utf8.Length = di->n - strlen(xapref);
+                    dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, dc->utf8.MaximumLength, ALLOC_TAG);
+                    if (!dc->utf8.Buffer) {
+                        ERR("out of memory\n");
+                        ExFreePool(dc);
+                        free_fcb(fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+                    
+                    RtlCopyMemory(dc->utf8.Buffer, &di->name[strlen(xapref)], dc->utf8.Length);
+                    
+                    dc->name.MaximumLength = dc->name.Length = utf16len;
+                    dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, dc->name.MaximumLength, ALLOC_TAG);
+                    if (!dc->name.Buffer) {
+                        ERR("out of memory\n");
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(fcb);
+                        return STATUS_INSUFFICIENT_RESOURCES;
+                    }
+                    
+                    Status = RtlUTF8ToUnicodeN(dc->name.Buffer, utf16len, &utf16len, dc->utf8.Buffer, dc->utf8.Length);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUTF8ToUnicodeN 2 returned %08x\n", Status);
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc->name.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(fcb);
+                        return Status;
+                    }
+                    
+                    Status = RtlUpcaseUnicodeString(&dc->name_uc, &dc->name, TRUE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
+                        ExFreePool(dc->utf8.Buffer);
+                        ExFreePool(dc->name.Buffer);
+                        ExFreePool(dc);
+                        free_fcb(fcb);
+                        return Status;
+                    }
+                    
+                    dc->size = di->m;
+                    
+                    InsertTailList(&fcb->dir_children_index, &dc->list_entry_index);
                 }
-            } else if (tp.item->key.offset == EA_NTACL_HASH) {
-                UINT16 buflen;
                 
-                if (extract_xattr(tp.item->data, tp.item->size, EA_NTACL, (UINT8**)&fcb->sd, &buflen)) {
-                    if (get_sd_from_xattr(fcb, buflen)) {
-                        sd_set = TRUE;
-                    } else
-                        ExFreePool(fcb->sd);
-                }
-            }
+                len -= offsetof(DIR_ITEM, name[0]) + di->m + di->n;
+                
+                if (len < offsetof(DIR_ITEM, name[0]))
+                    break;
+                
+                di = (DIR_ITEM*)&di->name[di->m + di->n];
+            } while (TRUE);
         } else if (tp.item->key.obj_type == TYPE_EXTENT_DATA) {
             extent* ext;
             BOOL unique = FALSE;
@@ -1118,7 +980,7 @@
             ed = (EXTENT_DATA*)tp.item->data;
             
             if (tp.item->size < sizeof(EXTENT_DATA)) {
-                ERR("(%llx,%x,%llx) was %llx bytes, expected at least %llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
+                ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
                     tp.item->size, sizeof(EXTENT_DATA));
                 
                 free_fcb(fcb);
@@ -1129,7 +991,7 @@
                 EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
                 
                 if (tp.item->size < sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
-                    ERR("(%llx,%x,%llx) was %llx bytes, expected at least %llx\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
+                    ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset,
                         tp.item->size, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2));
                 
                     free_fcb(fcb);
@@ -1136,7 +998,7 @@
                     return STATUS_INTERNAL_ERROR;
                 }
                 
-                if (ed2->address == 0 && ed2->size == 0) // sparse
+                if (ed2->address == 0 || ed2->size == 0) // sparse
                     continue;
                 
                 if (ed2->size != 0 && is_tree_unique(Vcb, tp.tree, Irp))
@@ -1143,7 +1005,7 @@
                     unique = is_extent_unique(Vcb, ed2->address, ed2->size, Irp);
             }
             
-            ext = ExAllocatePoolWithTag(pooltype, sizeof(extent), ALLOC_TAG);
+            ext = ExAllocatePoolWithTag(pooltype, offsetof(extent, extent_data) + tp.item->size, ALLOC_TAG);
             if (!ext) {
                 ERR("out of memory\n");
                 free_fcb(fcb);
@@ -1150,46 +1012,14 @@
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
             
-            ext->data = ExAllocatePoolWithTag(pooltype, tp.item->size, ALLOC_TAG);
-            if (!ext->data) {
-                ERR("out of memory\n");
-                ExFreePool(ext);
-                free_fcb(fcb);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
             ext->offset = tp.item->key.offset;
-            RtlCopyMemory(ext->data, tp.item->data, tp.item->size);
+            RtlCopyMemory(&ext->extent_data, tp.item->data, tp.item->size);
             ext->datalen = tp.item->size;
             ext->unique = unique;
             ext->ignore = FALSE;
             ext->inserted = FALSE;
+            ext->csum = NULL;
             
-            if (ed->type == EXTENT_TYPE_REGULAR && !(fcb->inode_item.flags & BTRFS_INODE_NODATASUM)) {
-                EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ed->data[0];
-                UINT64 len;
-                
-                len = (ed->compression == BTRFS_COMPRESSION_NONE ? ed2->num_bytes : ed2->size) / Vcb->superblock.sector_size;
-                
-                ext->csum = ExAllocatePoolWithTag(NonPagedPool, len * sizeof(UINT32), ALLOC_TAG);
-                if (!ext->csum) {
-                    ERR("out of memory\n");
-                    ExFreePool(ext);
-                    free_fcb(fcb);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                Status = load_csum(Vcb, ext->csum, ed2->address + (ed->compression == BTRFS_COMPRESSION_NONE ? ed2->offset : 0), len, Irp);
-                
-                if (!NT_SUCCESS(Status)) {
-                    ERR("load_csum returned %08x\n", Status);
-                    ExFreePool(ext);
-                    free_fcb(fcb);
-                    return Status;
-                }
-            } else
-                ext->csum = NULL;
-            
             InsertTailList(&fcb->extents, &ext->list_entry);
         }
     }
@@ -1218,7 +1048,7 @@
     }
     
     if (!atts_set)
-        fcb->atts = get_file_attributes(Vcb, &fcb->inode_item, fcb->subvol, fcb->inode, fcb->type, utf8 && utf8->Buffer[0] == '.', TRUE, Irp);
+        fcb->atts = get_file_attributes(Vcb, fcb->subvol, fcb->inode, fcb->type, utf8 && utf8->Buffer[0] == '.', TRUE, Irp);
     
     if (!sd_set)
         fcb_get_sd(fcb, parent, FALSE, Irp);
@@ -1245,8 +1075,7 @@
     return STATUS_SUCCESS;
 }
 
-NTSTATUS open_fcb_stream(device_extension* Vcb, root* subvol, UINT64 inode, ANSI_STRING* xattr,
-                         UINT32 streamhash, fcb* parent, fcb** pfcb, PIRP Irp) {
+static NTSTATUS open_fcb_stream(device_extension* Vcb, root* subvol, UINT64 inode, dir_child* dc, fcb* parent, fcb** pfcb, PIRP Irp) {
     fcb* fcb;
     UINT8* xattrdata;
     UINT16 xattrlen, overhead;
@@ -1254,7 +1083,22 @@
     KEY searchkey;
     traverse_ptr tp;
     LIST_ENTRY* lastle = NULL;
+    static char xapref[] = "user.";
+    ANSI_STRING xattr;
+    UINT32 crc32;
     
+    xattr.Length = strlen(xapref) + dc->utf8.Length;
+    xattr.MaximumLength = xattr.Length + 1;
+    xattr.Buffer = ExAllocatePoolWithTag(PagedPool, xattr.MaximumLength, ALLOC_TAG);
+    if (!xattr.Buffer) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+    
+    RtlCopyMemory(xattr.Buffer, xapref, strlen(xapref));
+    RtlCopyMemory(&xattr.Buffer[strlen(xapref)], dc->utf8.Buffer, dc->utf8.Length);
+    xattr.Buffer[xattr.Length] = 0;
+    
     if (!IsListEmpty(&subvol->fcbs)) {
         LIST_ENTRY* le = subvol->fcbs.Flink;
                                 
@@ -1262,8 +1106,8 @@
             fcb = CONTAINING_RECORD(le, struct _fcb, list_entry);
             
             if (fcb->inode == inode) {
-                if (fcb->ads && fcb->adsxattr.Length == xattr->Length &&
-                    RtlCompareMemory(fcb->adsxattr.Buffer, xattr->Buffer, fcb->adsxattr.Length) == fcb->adsxattr.Length) {
+                if (fcb->ads && fcb->adsxattr.Length == xattr.Length &&
+                    RtlCompareMemory(fcb->adsxattr.Buffer, xattr.Buffer, fcb->adsxattr.Length) == fcb->adsxattr.Length) {
 #ifdef DEBUG_FCB_REFCOUNTS
                     LONG rc = InterlockedIncrement(&fcb->refcount);
 
@@ -1271,6 +1115,7 @@
 #else
                     InterlockedIncrement(&fcb->refcount);
 #endif
+                    ExFreePool(xattr.Buffer);
 
                     *pfcb = fcb;
                     return STATUS_SUCCESS;
@@ -1284,32 +1129,36 @@
         }
     }
     
-    fcb = create_fcb(PagedPool);
+    fcb = create_fcb(Vcb, PagedPool);
     if (!fcb) {
         ERR("out of memory\n");
+        ExFreePool(xattr.Buffer);
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-      
-    if (!get_xattr(Vcb, parent->subvol, parent->inode, xattr->Buffer, streamhash, &xattrdata, &xattrlen, Irp)) {
+    
+    fcb->Vcb = Vcb;
+    
+    crc32 = calc_crc32c(0xfffffffe, (UINT8*)xattr.Buffer, xattr.Length);
+
+    if (!get_xattr(Vcb, parent->subvol, parent->inode, xattr.Buffer, crc32, &xattrdata, &xattrlen, Irp)) {
         ERR("get_xattr failed\n");
         free_fcb(fcb);
+        ExFreePool(xattr.Buffer);
         return STATUS_INTERNAL_ERROR;
     }
 
-    fcb->Vcb = Vcb;
-    
     fcb->subvol = parent->subvol;
     fcb->inode = parent->inode;
     fcb->type = parent->type;
     fcb->ads = TRUE;
-    fcb->adshash = streamhash;
-    fcb->adsxattr = *xattr;
+    fcb->adshash = crc32;
+    fcb->adsxattr = xattr;
     
     // find XATTR_ITEM overhead and hence calculate maximum length
     
     searchkey.obj_id = parent->inode;
     searchkey.obj_type = TYPE_XATTR_ITEM;
-    searchkey.offset = streamhash;
+    searchkey.offset = crc32;
 
     Status = find_item(Vcb, parent->subvol, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
@@ -1356,131 +1205,94 @@
     return STATUS_SUCCESS;
 }
 
-void insert_fileref_child(file_ref* parent, file_ref* child, BOOL do_lock) {
-    if (do_lock)
-        ExAcquireResourceExclusiveLite(&parent->nonpaged->children_lock, TRUE);
-    
-    if (IsListEmpty(&parent->children))
-        InsertTailList(&parent->children, &child->list_entry);
-    else {
-        LIST_ENTRY* le = parent->children.Flink;
-        file_ref* fr1 = CONTAINING_RECORD(le, file_ref, list_entry);
-        
-        if (child->index < fr1->index)
-            InsertHeadList(&parent->children, &child->list_entry);
-        else {
-            while (le != &parent->children) {
-                file_ref* fr2 = (le->Flink == &parent->children) ? NULL : CONTAINING_RECORD(le->Flink, file_ref, list_entry);
-                
-                if (child->index >= fr1->index && (!fr2 || fr2->index > child->index)) {
-                    InsertHeadList(&fr1->list_entry, &child->list_entry);
-                    break;
-                }
-                
-                fr1 = fr2;
-                le = le->Flink;
-            }
-        }
-    }
-    
-    if (do_lock)
-        ExReleaseResourceLite(&parent->nonpaged->children_lock);
-}
-
-static NTSTATUS open_fileref_child(device_extension* Vcb, file_ref* sf, PUNICODE_STRING name, BOOL case_sensitive, BOOL lastpart, BOOL streampart,
-                                   POOL_TYPE pooltype, file_ref** psf2, PIRP Irp) {
+NTSTATUS open_fileref_child(device_extension* Vcb, file_ref* sf, PUNICODE_STRING name, BOOL case_sensitive, BOOL lastpart, BOOL streampart,
+                            POOL_TYPE pooltype, file_ref** psf2, PIRP Irp) {
     NTSTATUS Status;
     file_ref* sf2;
         
     if (streampart) {
-        UNICODE_STRING streamname;
-        ANSI_STRING xattr;
-        UINT32 streamhash;
+        BOOL locked = FALSE;
+        LIST_ENTRY* le;
+        UNICODE_STRING name_uc;
+        dir_child* dc = NULL;
+        fcb* fcb;
         
-        sf2 = search_fileref_children(sf, name, case_sensitive);
+        if (!case_sensitive) {
+            Status = RtlUpcaseUnicodeString(&name_uc, name, TRUE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
+                return Status;
+            }
+        }
         
-        if (sf2) {
-            if (sf2->deleted) {
-                TRACE("element in path has been deleted\n");
-                free_fileref(sf2);
-                return lastpart ? STATUS_OBJECT_NAME_NOT_FOUND : STATUS_OBJECT_PATH_NOT_FOUND;
-            }
+        if (!ExIsResourceAcquiredSharedLite(&sf->fcb->nonpaged->dir_children_lock)) {
+            ExAcquireResourceSharedLite(&sf->fcb->nonpaged->dir_children_lock, TRUE);
+            locked = TRUE;
+        }
+        
+        le = sf->fcb->dir_children_index.Flink;
+        while (le != &sf->fcb->dir_children_index) {
+            dir_child* dc2 = CONTAINING_RECORD(le, dir_child, list_entry_index);
             
-            *psf2 = sf2;
-    
-            return STATUS_SUCCESS;
+            if (dc2->index == 0) {
+                if ((case_sensitive && dc2->name.Length == name->Length && RtlCompareMemory(dc2->name.Buffer, name->Buffer, dc2->name.Length) == dc2->name.Length) ||
+                    (!case_sensitive && dc2->name_uc.Length == name_uc.Length && RtlCompareMemory(dc2->name_uc.Buffer, name_uc.Buffer, dc2->name_uc.Length) == dc2->name_uc.Length)
+                ) {
+                    dc = dc2;
+                    break;
+                }
+            } else
+                break;
+            
+            le = le->Flink;
         }
         
-        streamname.Buffer = NULL;
-        streamname.Length = streamname.MaximumLength = 0;
-        xattr.Buffer = NULL;
-        xattr.Length = xattr.MaximumLength = 0;
+        if (!case_sensitive)
+            ExFreePool(name_uc.Buffer);
         
-        // FIXME - check if already opened
+        if (locked)
+            ExReleaseResourceLite(&sf->fcb->nonpaged->dir_children_lock);
         
-        if (!find_stream(Vcb, sf->fcb, name, &streamname, &streamhash, &xattr, Irp)) {
-            TRACE("could not find stream %.*S\n", name->Length / sizeof(WCHAR), name->Buffer);
-            
+        if (!dc)
             return STATUS_OBJECT_NAME_NOT_FOUND;
-        } else {
-            fcb* fcb;
+        
+        if (dc->fileref) {
+            increase_fileref_refcount(dc->fileref);
+            *psf2 = dc->fileref;
+            return STATUS_SUCCESS;
+        }
 
-            if (streamhash == EA_DOSATTRIB_HASH && xattr.Length == strlen(EA_DOSATTRIB) &&
-                RtlCompareMemory(xattr.Buffer, EA_DOSATTRIB, xattr.Length) == xattr.Length) {
-                WARN("not allowing user.DOSATTRIB to be opened as stream\n");
-            
-                return STATUS_OBJECT_NAME_NOT_FOUND;
-            }
-            
-            Status = open_fcb_stream(Vcb, sf->fcb->subvol, sf->fcb->inode, &xattr, streamhash, sf->fcb, &fcb, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("open_fcb_stream returned %08x\n", Status);
-                return Status;
-            }
-            
-            sf2 = create_fileref();
-            if (!sf2) {
-                ERR("out of memory\n");
-                free_fcb(fcb);
-                return STATUS_INSUFFICIENT_RESOURCES;
-            }
-            
-            sf2->fcb = fcb;
+        Status = open_fcb_stream(Vcb, sf->fcb->subvol, sf->fcb->inode, dc, sf->fcb, &fcb, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("open_fcb_stream returned %08x\n", Status);
+            return Status;
+        }
+        
+        sf2 = create_fileref(Vcb);
+        if (!sf2) {
+            ERR("out of memory\n");
+            free_fcb(fcb);
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+        
+        sf2->fcb = fcb;
 
-            if (streamname.Buffer) // case has changed
-                sf2->filepart = streamname;
-            else {
-                sf2->filepart.MaximumLength = sf2->filepart.Length = name->Length;
-                sf2->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, sf2->filepart.MaximumLength, ALLOC_TAG);
-                if (!sf2->filepart.Buffer) {
-                    ERR("out of memory\n");
-                    free_fileref(sf2);
-                    return STATUS_INSUFFICIENT_RESOURCES;
-                }
-                
-                RtlCopyMemory(sf2->filepart.Buffer, name->Buffer, name->Length);
-            }
-            
-            Status = RtlUpcaseUnicodeString(&sf2->filepart_uc, &sf2->filepart, TRUE);
-            if (!NT_SUCCESS(Status)) {
-                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-                free_fileref(sf2);
-                return Status;
-            }
-            
-            // FIXME - make sure all functions know that ADS FCBs won't have a valid SD or INODE_ITEM
+        sf2->parent = (struct _file_ref*)sf;
+        
+        sf2->dc = dc;
+        dc->fileref = sf2;
 
-            sf2->parent = (struct _file_ref*)sf;
-            insert_fileref_child(sf, sf2, TRUE);
-            
-            increase_fileref_refcount(sf);
-        }
+        ExAcquireResourceExclusiveLite(&sf->nonpaged->children_lock, TRUE);
+        InsertTailList(&sf->children, &sf2->list_entry);
+        ExReleaseResourceLite(&sf->nonpaged->children_lock);
+
+        increase_fileref_refcount(sf);
     } else {
         root* subvol;
         UINT64 inode;
         dir_child* dc;
         
-        Status = find_file_in_dir(Vcb, name, sf->fcb, &subvol, &inode, &dc, case_sensitive, Irp);
+        Status = find_file_in_dir(name, sf->fcb, &subvol, &inode, &dc, case_sensitive);
         if (Status == STATUS_OBJECT_NAME_NOT_FOUND) {
             TRACE("could not find %.*S\n", name->Length / sizeof(WCHAR), name->Buffer);
 
@@ -1490,6 +1302,9 @@
             return Status;
         } else {
             fcb* fcb;
+#ifdef DEBUG_STATS
+            LARGE_INTEGER time1, time2;
+#endif
             
             if (dc->fileref) {
                 if (!lastpart && dc->type != BTRFS_TYPE_DIRECTORY) {
@@ -1502,7 +1317,16 @@
                 return STATUS_SUCCESS;
             }
             
+#ifdef DEBUG_STATS
+            time1 = KeQueryPerformanceCounter(NULL);
+#endif
             Status = open_fcb(Vcb, subvol, inode, dc->type, &dc->utf8, sf->fcb, &fcb, pooltype, Irp);
+#ifdef DEBUG_STATS
+            time2 = KeQueryPerformanceCounter(NULL);
+            Vcb->stats.open_fcb_calls++;
+            Vcb->stats.open_fcb_time += time2.QuadPart - time1.QuadPart;
+#endif            
+            
             if (!NT_SUCCESS(Status)) {
                 ERR("open_fcb returned %08x\n", Status);
                 return Status;
@@ -1514,7 +1338,7 @@
                 return STATUS_OBJECT_PATH_NOT_FOUND;
             }
 
-            sf2 = create_fileref();
+            sf2 = create_fileref(Vcb);
             if (!sf2) {
                 ERR("out of memory\n");
                 free_fcb(fcb);
